2021-11-15
Fix: RoundUp, Floor, Ceil functions
New: WAV/MP3 audio player expression commands
New: Beep and Siren sound expression commands
New: Midi settings
Fix: Rotational axis homing
New: Serial read/write (M65)
New: "crc16" comment function for calculating Modbus CRC.

2021-10-20
New: Wireless handwheel button configuration with "Handwheel.txt" file
New; Expression commands rgb2hue, rgb2sat, rgb2lum, rubik, url, sha256, sha256_f, md5, md5_f, cam_grab, cam_color, cam_rect

2021-10-08
Mod: Performance optimizations
Fix: Missing axis name in measuring results
Fix: Rounding issue in cycle return plane height
API: Arduino examples are modified to support Arduino Due
API: Example for 7" coordinate display 
Fix: Tangential knife orientation in dxf import

2021-08-26
Fix: Toolchange position in tooltable

2021-08-12
Mod: More options for setting tool offset during toolchange. 
Mod: Spline interpolation improved.
Mod: Support for flipped horizontals in dxf arcs and circles.
New: Support for command line parameters in python (see cmdargs.py example)
Fix: Spindle and feed speed in cycles when multiple lines are used ad word is in first line

2021-06-17
Mod: Some small fixes

2021-06-01
Mod: Updated G-Code manual
New: Nested interpreters are now supported. Subinterpreters are now stack based and MDI/jogging commands are possible.
New: Additional tool parameters
New: Speed and feed calculator!!!
Mod: Measuring scripts updated and implemented as O macros
New: Probe calibration 
New: Cooling interval option
New: Wireless pendant can OK/Close dialogs
New: Cycle command group and couple of cycles
New: Operator panel with "distance to travel"
New: Expr.txt events #OnJog and #OnCmd
New: Second bottom toolbar with BtnBottom2.txt
New: Many other small features and improvements

2021-03-02
Fix: Tool radius left/right swap
Fix: "Start From Selected Line" with incremental (G91) g-code
Fix: Wireless pendant follows work offset/coord system settings
Fix: File filters for kdialog

2021-02-16
New: M11P10 /M11P11 g-code to turn soft limits on/off
New: #OnStart Expr.txt event
New: #OnEnd Expr.txt event
New: #OnStop Expr.txt event
New: #OnEStop Expr.txt event

2021-02-12
Fix: Tool radius bug
Fix: Case sensitivity in external scripts

2021-01-12
New: Tooltable parameters are now read/write
Fix: Bug with resursive subprocedures

2020-12-16
Fix: Refresh issues during paused g-code
New: Remove entry from recent files with Ctrl+Shift

2020-12-08
New: Import CAD option for smooth
Fix: Import CAD bugs

2020-11-24
New: G-code (clipboard)
New: SVG import
New: Import CAD option for union and offset
Fix: Limit input for 9th axis
Mod: Work offset is not reset by entering settings
Mod: Home positions are not reset by entering settings
Fix: Backlash rounding error
New: More options for displying tool name during tool change
New: Parameter '_hw_output_freqN' and '_hw_output_dutyN'

2020-10-16
New: Plugin API for C/C++ plugins
Mod: USB enumeration
New: Use E word setting for 3D printers
New: G-code functions U8, S8, U16, S16, U32, S32
New: G-code functions ToU8, ToS8, ToU16, ToS16, ToU32, ToS32
New: G-code functions FromU8, FromS8, FromU16, FromS16, FromU32, FromS32
New: G-code function Expr
New: Parameter '_expr' for Expr result
New: G-code (print) with hex formatting
Mod: Internal subprocedures are now visible from sublevels
Mod: Local argument parameters are no longer changed in subprocedures
New: Parameter '_hw_isprog'
New: Parameter '_hw_iscmd'
New: Parameter '_hw_isjog'

2020-09-20
New: RTL text direction support in localization
New: Execute MIDI commands

2020-09-18
Fix: Removed some testing leftovers

2020-09-12
Fix: Rounding bug in backlash (this time for real)

2020-09-10
New: Spindle IndexRPM divisor setting.
Fix: Rounding bug in backlash
Mod: German localisation
Mod: Maximum allowable values in measuring dialogs increased

2020-08-27
New: Usb commands can be automatically executed if condition is true
New: 'py' and 'pythr' expr functions
Fix: Nested strings in expressions
New: '(paramsclear)' gcode command
Mod: Parameters are no longer cleared when entering settings
New: Support for dxf files with incorrect vertex counts
New: Warning for "Revert to V1" command
Fix: Last character in print command was truncated
Fix: Jog commands were not part of Jog group

2020-07-31
New: Usb plugin device now has separate read and write expressions 
New: Multiple Expr.txt files
New: Expr.txt #OnInit and #OnShutdown sections
Fix: Settings window could be under Script window
New: New _warp_offset parameter
New: Work and CS measure scripts now compensate for warp offset
Fix: Measure surface script 
New: Probe EStop setting

2020-07-21
Mod: Tool measure script now uses work coordinates for return
Mod: M6 script now uses work coordinates for return
New: Python gcode.open() command
Mod: Maximum possible speed override increased to 1000%
Fix: Warp with points in inches

2020-06-18
Fix: Editing of large programs
Fix: Mpg display
Fix: Warp in inch units
New: Settings for motionless coordinates
New: Improved trajectory planner

2020-05-18
Fix: Freeze with large programs
Fix: Mpg display
New: Custom toolbar buttons

2020-05-14
New: Parameters for THC settings

2020-04-30
Fix: Bug with slow jogging via API
Fix: 3D grid had wrong point locations
Fix: Option to exclude tool offset had problems with arcs
Fix: Extents now include arc bulges
New: Shapes collection
New: G06.1 g-code
New: G06.2 H1 g-code
New: G06.2 H2 g-code
New: G06 g-code
Mod: Dxf import algorithms
New: Dxf import spline to arc interpolation
New: Dxf export new options

2020-03-24
Fix: Firmware update in NET controllers
Fix: Manual toolchange script
New: Commands to unwind rotary axes
New: Machine 3d visualization
New: Option to exclude tool offset from g-code
New: Option to include tool offset on tool marker

2020-03-14
New: Tool sensor position visualized
New: G28 and G30 position visualized
New: Mpg and JogKbd now have faster and continuous step mode
Fix: Bug in homing (and other measure) scripts

2020-03-12
New: ToolOffset Rapid Height setting
New: Option to set THC speed and acceleration limits
Api: New commands for dialogs
New: Dialogs in Python
New: Dialog options to hide "cancel" button
Mod: More reliable "LineNumber"
Fix: With G61 deceleration was incorrect

2020-03-06
Api: Command for file open dialog
Pyt: Commands to read image pixel values
New: Parameter '_thcen'
New: Indicator to show if THC is enabled and active

2020-02-28
Api: New SPI and SPIpin command for ExtOut boards
Fix: Reverse setting for spindle encoder
New: THC inc and dec via API
Mod: No finishing pass for g-code G12/G13 with H0
Fix: Show Log crashes on MacOS
Api: LineNumCB
New: New parameters for CVS export 
Fix: Comments without ( were also executed
New: Option to hide yellow position cone, to send it front/back and set color to transparent
New: PWM improvments for high speed laser engraving/printing
New: Support for g-code files with CR line endings

2020-02-12
New: Manually adding points
New: (pointpos) G-code
Fix: Shortcuts for step jogging of XY and UV diagonal axes
Fix: PotCenter setting caused crash in some cases
Mod: Spindle synchronization response improved
Api: Fixed "LineList" commands
Api: New "GetProfilePath" command
New: Option to reverse single axis with MPG.

2020-02-07
New: Translation to Dutch, French, German, Italian, Portuguese, Russian, Slovenian, Spanish
Fix: M98/M99 issue
Fix: Save button on MacOS version was not enabled
Mod: Transparency for hover and selected g-code display improved
New: G76 lathe threading g-code implemented
Fix: Editing non-unicode g-code with invalid characters
Fix: Arc g-code without G2, G3 and axis words (only IJK)

2020-01-26
New: 3D alpha setting for traverse moves
Fix: Some missing translations
Fix: Weird bug in cycles
Fix: EStop events incorrectly triggered on normal Stop

2020-01-17
Fix: Wireless handwheel - wrong leading zeros on display
Mod: Tool table dialog is now resizable
Mod: Coordinate systems dialog is now resizable
Fix: Work position sometimes incorrectly displays Z coordinate when Warp is disabled
Fix: Probe input canceled pause
New: Save points to DXF file
New: Motion state is set to G80 on interpreter reset
New: Settings/Scripts remember last selection
New: Separate Speed Override Min/Max settings for feed and traverse
Fix: Typing number starting with dot in position panel triggered an error
Fix: Command scripts are selecting loaded g-code lines
Fix: Transformations and drill cycles
New: Status LEDs
New: G-code dialogs and messages OK/Cancel buttons are clicked by Start, Stop and EStop shortcuts
Fix: Toolpath history coordinates were incorrect in some cases
Mod: THC - support for packets larger than 1
New: Jogging and probe axis lock
New: Parameters _hw_axislock, _prog_maxspeed, _prog_minspeed, _prog_maxspindle, _prog_minspindle
New: G73 drill cycle now supports partial retract
New: (msg) and (print) now support displaying tool names.
New: Tool names displayed on toolchange
New: Toolchange supports message and pause at same time
New: Toolchange script now handles spindle
Fix: Outputs/Spindle/Coolant pins were turned off on probe if EStop event was set
Fix: Spindle direction pin retains state on spindle off

2020-01-03
Fix: Some localization issues
Fix: JogPot setting in inch units
Mod: Driver digital signature updated
Fix: Firmware update issue

2019-12-20
New: Different speeds for ATC move 1 and 2
New: Tooltable option to skip tool (for example laser as secondary spindle)
New: THC for plasma machines
Mod: Program/Shift - presets
Fix: Machine/Work Position/Camera XY script
Fix: Inverted output initial state
Mod: Support for 3D transformations

2019-12-12
Fix: Dxf dialog import in inch units
Fix: HPGL import dialog in inch units
Fix: Gerber import dialog in inch units
Fix: Machine/Work Position/Camera XY script
New: Toolchange ATC script
Fix: Machine/Start commands -> renamed because of duplicate names

2019-12-06
Fix: Simulation flood and mist fixed
New: word parameters in M-code scripts (PQRDEHL)
Mod: Mill Cycles are now fully implemented (including both packing codes G83 and G73)
Mod: G12, G13 are now fully implemented
New: G-code function 'Active[]'
New: Start from selected line - option to restore state
New: Start from selected line - restored motion mode
Fix: Units issue with G20 active and UI in millimeters
Fix: G33 and pause bug
Mod: Renamed menu Machine/Advanced to Machine/Start 
Mod: Reorganized Machine/Options menu
New: Simulation of probe trigger
New: Toolchange Autoreturn

2019-11-29
New: USB expansion boards support commands from G-code
Mod: M61 G-code no longer changes selected tool parameter
New: API example ProjectMicro2 for Arduino
Mod: Python perfomance tweaks
Mod: Consolidated Program Options setting pages
New: Restore state on estop and stop
Fix: G10L9 with G91 bug
New: Tooltable - sensor offset setting
New: Tooltable - user parameters
New: Toolchanger settings (ATC is still on TODO)

2019-11-22
Fix: Sync 3D color
Mod: OnStart script now supports parameters posstate_x..w, miststate, floodstate, spindlestate, motorsstate, limitsstate
Fix: G33 bug
Fix: Spindle Sync Signal setting
Fix: ExtIn problems
New: ExtIn pin as shortcut
New: Spindle, Mist and Flood now work even if output pins are not set 
Fix: Small bug in G33.1
New: Single Step
New: Start/Stop shortcuts for OK/Cancel in dialogs
Fix: Line numbers on comments were incorrect

2019-11-15
New: New parameters: _motoroutputorder_axis, _motoroutputreverse_axis
New: New parameters: _motorspu_axis, _motorspeed_axis, _motoracc_axis, _motordec_axis
New: Support for gantry squaring measurements
Fix: Freeze during dwell
New: EStop event "Outputs Off"
Mod: Blend angle calculation optimization
New: UserGen and UserCmd examples
New: New parameters: '_tooloff_axis', '_workoff_axis', '_axisoff_axis', '_coordsys_axis'
Fix: Some glitches in measurements
Fix: Tool offset measuring script
New: MDI history delete and reorder features
Mod: Measure height scripts
Mod: Spindle settings

2019-11-08
New: G43 and G44 tool offset g-code - added support for G0 and G1 on same line.
Fix: Bug with autoremoved subroutine.
Fix: Zoom to part when no program is loaded.
Fix: Windows installation now asks for target folder
Fix: Installation files for Linux and MacOS
New: Expression functions 'startfn' and 'startcode'
New: Python 'result' object
Mod: InfoPosition API is faster
New: 'tooltip=' custom button attribute
Fix: 'Inc' and 'Dec' g-code functions
New: 'Def' function
New: Clickig 'Cancel' on g-code dialog will trigger 'OnStop' script
New: Expression operators '&&', '||' and '!'
New: Automatically generate 'Script', 'UserCmd' and 'UserGen' folders
New: Support for ExtIn and ExtOut boards
New: New options for '(arrchr)' g-code comment
Mod: M64 now supports data reading (R and D words, M64ex7.txt sample file)
Note: Mill Cycles are partially completed
Note: G12, G13 are partially completed


2019-10-28
First beta version of TNG v2

2019-08-15
First "preview" version of TNG v2

---------------------------------------------------------------------------------
Latest API: https://planet-cnc.com/wp-content/uploads/sw/PlanetCNC_API.zip
Latest Doc: https://planet-cnc.com/wp-content/uploads/sw/PlanetCNC_Doc.zip
Latest Samples: https://planet-cnc.com/wp-content/uploads/sw/PlanetCNC_Samples.zip
Latest Driver: https://planet-cnc.com/wp-content/uploads/sw/PlanetCNC_Driver.zip
---------------------------------------------------------------------------------



TODO: Probe Rectangle Pocket
TODO: Probe Rectangle Block
TODO: Probe Angle of corner

TODO: Mill Cycles
TODO: Lathe Cycles
TODO: Lathe CSS (G96/G97)
TODO: Image Import
TODO: G06 "Shapes" g-code
TODO: 3D printer example


TODO: Output pin - EStop event
TODO: Output pin - Error event
TODO: Output pin - Pause event
TODO: Output pin - Start event
TODO: Output pin - Stop event
TODO: Output pin - Dwell event
TODO: Output pin - Move event
TODO: Output pin - Constant Speed event
TODO: Output pin - Acceleration event
TODO: Output pin - Deceleration event
TODO: Output pin - Signal 12.5kHz 
TODO: Output pin - Signal 1Hz 








